package com.ai.abc.jpa.elastic.model;

import com.ai.abc.core.model.AbstractModel;
import com.ai.abc.util.serializer.BusinessObjectsSerializer;
import com.alibaba.fastjson.JSONObject;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * 描述
 *
 * @author
 * @createDate
 */
@NoArgsConstructor
@Getter
@Setter
public class ElasticPage <T extends Serializable> extends AbstractModel {
    private long totalSize;

    private int startNumber;

    private int pageSize;

    private List<JSONObject> results;

    public <T> List<T> getList(Class<T> clazz) {
        List<T> list = new ArrayList();
        for(JSONObject jsonObject : results) {
            T dtoTemp = BusinessObjectsSerializer.deserialize(jsonObject.toJSONString(), clazz);
            list.add(dtoTemp);
        }

        return list;
    }
}
