package com.ai.bss.es.esmanage.controller;

import com.ai.bss.es.esmanage.service.EsService;
import com.ai.bss.es.esmanage.utils.RequestEntity;
import com.ai.bss.es.esmanage.utils.ResponseResult;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;

@Slf4j
@RestController
@RequestMapping("/es")
public class EsController {

    @Autowired
    private EsService esService;

    @PostMapping("/execute")
    ResponseResult execute(@RequestBody RequestEntity requestEntity) throws Exception {

        log.info("requestEntity:\n"+JSONObject.toJSONString(requestEntity));
        return esService.executeEsEntity(requestEntity);
    }


    @PostMapping("/countSearch")
    ResponseResult countSearch(@RequestBody RequestEntity requestEntity) throws Exception {

        log.info("requestEntity:\n"+JSONObject.toJSONString(requestEntity));
        return esService.countSearch(requestEntity,null,"COUNT");
    }

}