package com.ai.bss.es.esmanage.utils;

import org.apache.http.HttpHost;
import org.elasticsearch.client.RestClient;
import org.elasticsearch.client.RestHighLevelClient;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * 给容器中注入一个RestHighLevelClient
 */
@Configuration
public class ElasticSearchConfig {

    @Value("${es.server:Empty}")
    String esServer ;

    @Value("${es.server.port:Empty}")
    Integer esServerPort ;

    @Bean
    public RestHighLevelClient esRestClient(){
        RestHighLevelClient client = new RestHighLevelClient(
                RestClient.builder(
                        //在这里配置你的elasticsearch的情况
                        new HttpHost(esServer, esServerPort, "http")
                )
        );
        return client;
    }
}
