package com.ai.bss.es.esmanage;

import com.ai.abc.jpa.elastic.model.ElasticPage;
import com.ai.abc.jpa.elastic.model.PageInfo;
import com.ai.abc.jpa.elastic.model.TimeInfo;
import com.ai.abc.jpa.elastic.repository.ElasticEntityRepository;
import com.ai.abc.jpa.elastic.repository.impl.ElasticEntityRepositoryImpl;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import org.elasticsearch.action.search.SearchRequest;
import org.elasticsearch.action.search.SearchRequestBuilder;
import org.elasticsearch.action.search.SearchResponse;
import org.elasticsearch.client.RequestOptions;
import org.elasticsearch.client.RestHighLevelClient;
import org.elasticsearch.index.query.BoolQueryBuilder;
import org.elasticsearch.index.query.MatchQueryBuilder;
import org.elasticsearch.index.query.QueryBuilders;
import org.elasticsearch.search.SearchHit;
import org.elasticsearch.search.aggregations.AggregationBuilders;
import org.elasticsearch.search.aggregations.bucket.terms.TermsAggregationBuilder;
import org.elasticsearch.search.aggregations.metrics.AvgAggregationBuilder;
import org.elasticsearch.search.builder.SearchSourceBuilder;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.*;

@SpringBootTest
class EsManageApplicationTests {


    @Autowired
    private RestHighLevelClient client;

    @Test
    void contextLoads()  {

        ElasticEntityRepository elasticEntityRepository = new ElasticEntityRepositoryImpl();
        elasticEntityRepository.initServer("47.105.160.21:10020");
//        JSONObject jsonObject = new JSONObject();
//        jsonObject.put("id", "113");
//        jsonObject.put("type", "1");
//        jsonObject.put("name", "yaxin12");
//        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
//        jsonObject.put("create_date", df.format(new Date()));
//
//        //插入
//        String entity = jsonObject.toString();
//
//        entity = "{\"dataExchangeProtocol\":\"Hex\",\"detailInfo\":\"2454585858002a0efa90600ef9f1000000b000b01409020a2d1c45672b1f024e1d0a12010000874d00b0\",\"eventSpecId\":57700004350,\"eventSpecName\":\"定位\",\"eventTime\":1603255716747,\"eventTimeStr\":\"2020-10-21 12:48:36 747\",\"eventTypeName\":\"上行消息\",\"imei\":\"\",\"messageTopic\":\"DW\",\"messageTypeId\":57700000031,\"physicalProtocol\":\"TCP\",\"resourceId\":981489,\"resourceName\":\"手持定位仪001\",\"resourceSpecId\":57700004344,\"terminalEventId\":21700,\"terminalSN\":\"\"}";
//        elasticEntityRepository.purePersist("es_terminal_event", "", entity);


        //查询
        Map jsonSearch = new HashMap();
        //jsonSearch.put("id", "101");
//        jsonSearch.put("type", "1");
        //jsonSearch.put("name", "yaxin");

        List<String> ids = new ArrayList<>();
        ids.add("981489");
        ids.add("155682");
        jsonSearch.put("resourceId", ids);

        PageInfo pageInfo = new PageInfo();
        pageInfo.setStartNumber(0);
        pageInfo.setPageSize(20);
//        Map jsonSearchMap = JSONObject.parseObject(jsonSearch.toJSONString(), new TypeReference<Map<String, String>>(){});
//        Map sortMap = new HashMap();
        TimeInfo timeInfo = new TimeInfo();
        timeInfo.setFieldName("eventTimeStr");
        timeInfo.setStartTime("2020-10-28 00:09:51");
        timeInfo.setEndTime("2020-10-28 00:09:53");
        ElasticPage elasticPage = elasticEntityRepository.findEntity("es_terminal_event", null, timeInfo, pageInfo,null);
        System.out.println(elasticPage.getResults());




//        List<String> ids = new ArrayList();
//        ids.add("981489");
//        ids.add("155682");
//        BoolQueryBuilder exersiceBoolQuery = QueryBuilders.boolQuery();
//        for (String exerciseId: ids)
//        {
//            exersiceBoolQuery.must(QueryBuilders.termQuery("resourceId", exerciseId));
//        }
//
//        SearchRequest request = new SearchRequest("es_terminal_event");

        //5、开始执行发送request请求
//        SearchResponse searchResponse = client.search(request, RequestOptions.DEFAULT);

//        SearchRequestBuilder searchRequestBuilder = client.prepareSearch("index name").setTypes("type name")
//                         .setQuery(exersiceBoolQuery)
//                        .addHighlightedField("*")/*星号表示在所有字段都高亮*/.setHighlighterRequireFieldMatch(false)//配置高亮显示搜索结果
//                .setHighlighterPreTags("<高亮前缀标签>").setHighlighterPostTags("<高亮后缀标签>");//配置高亮显示搜索结果
//
//                         searchRequestBuilder = searchRequestBuilder.addAggregation(AggregationBuilders.terms("agg1(聚类返回时根据此key获取聚类结果)")
//                                         .size(1000)/*返回1000条聚类结果*/.field("要在文档中聚类的字段，如果是嵌套的则用点连接父子字段，如【person.company.name】"));
//
//        SearchResponse searchResponse = searchRequestBuilder.setFrom((0) * 10)//分页起始位置（跳过开始的n个）
//                         .setSize(10)//本次返回的文档数量
//                         .execute().actionGet();//执行搜索


    }


    @Test
    List<String> inSearch() throws IOException {
        //1、创建查询请求，规定查询的索引
        SearchRequest request = new SearchRequest("es_terminal_event");
        //2、创建条件构造
        SearchSourceBuilder builder = new SearchSourceBuilder();
//        //3、构造条件
//        MatchQueryBuilder matchQueryBuilder = QueryBuilders.matchQuery("address", "Lane");
//        builder.query(matchQueryBuilder);
//        //聚合年龄分布
//        TermsAggregationBuilder ageAgg = AggregationBuilders.terms("ageAgg").field("age");
//        builder.aggregation(ageAgg);
////
////        //聚合平均年龄
//        AvgAggregationBuilder balanceAvg = AggregationBuilders.avg("balanceAvg").field("balance");
//        builder.aggregation(balanceAvg);

        List<String> ids = new ArrayList();
        ids.add("981489");
        ids.add("155682");
        BoolQueryBuilder exersiceBoolQuery = QueryBuilders.boolQuery();
        for (String exerciseId : ids) {
            exersiceBoolQuery.must(QueryBuilders.termQuery("resourceId", exerciseId));
        }
        builder.query(exersiceBoolQuery);

        //4、将构造好的条件放入请求中
        request.source(builder);

        //5、开始执行发送request请求
        SearchResponse searchResponse = client.search(request, RequestOptions.DEFAULT);
        //6、开始处理返回的数据
        SearchHit[] hits = searchResponse.getHits().getHits();
        List<String> list = new ArrayList<String>();
        for (SearchHit hit : hits) {
            String hitString = hit.getSourceAsString();
            System.out.println(hitString);
            list.add(hitString);
        }
        return list;
    }

    }
