package com.ai.abc.jpa.elastic.repository;

import com.ai.abc.jpa.elastic.model.ElasticPage;
import com.ai.abc.jpa.elastic.model.PageInfo;
import com.ai.abc.jpa.elastic.model.TimeInfo;

import java.io.IOException;
import java.io.Serializable;
import java.util.Date;
import java.util.List;
import java.util.Map;

public interface ElasticEntityRepository {

    void initServer(String esServer);

    void initServer(String esServer,String userName,String passWord);

    void purePersist(String tableName, String type, String entity);

    <T extends Serializable> ElasticPage<T> findEntity(String connectionName, Map<String, Object> hashMap, String startDate, String stopDate, PageInfo pageInfo);

//    <T extends Serializable> ElasticPage<T> findEntity(Object entity, Date startDate, Date stopDate, PageInfo pageInfo);


    <T extends Serializable> ElasticPage<T> findEntity(String paramString, Map<String, Object> paramMap, TimeInfo paramTimeInfo, PageInfo paramPageInfo, Map<String, String> paramMap1);


    long countSearch(String index,Map<String, Object> hashMap,TimeInfo timeInfo,String fuzzySearchStr) throws Exception;

    List<Map> countAndSearch(String index, Map<String, Object> hashMap, String groupField, TimeInfo timeInfo, String fuzzySearchStr) throws Exception;

    Map countAndGroupWhitEventTime(String index, Map<String, Object> hashMap,String groupField ,TimeInfo timeInfo,String fuzzySearchStr) throws Exception;
}
